import { sequelize } from '../modules/sequelize.ts';
import { initUser } from '../scripts/common.ts';
import '../scripts/common-redis.ts';
import { useContextKey } from '@kevisual/context';

export const main = async () => {
  const models = await initUser();

  const username = 'root';
  const orgname = 'admin';

  const user = await models.User.findOne({ where: { username } });
  const org = await models.User.findOne({ where: { username: orgname } });

  console.log('user.id', user?.id);
  console.log('org.id', org?.id);
  // const userSecret1 = await models.UserSecret.createSecret(user?.id!);
  // userSecret1.title = 'root secret';
  // await userSecret1.save();
  // await models.UserSecret.destroy({
  //   where: {
  //     orgId: '16a496d4-8cd6-4e02-b403-c2adc006a53d',
  //   },
  // });
  const userSecret2 = await models.UserSecret.createSecret(user?.id!, org?.id!);
  userSecret2.title = 'root org secret';
  await userSecret2.save();

  const secretList = await models.UserSecret.findAll();
  for (const secret of secretList) {
    console.log(`\nSecret ID: ${secret.id}, User ID: ${secret.userId}, Org ID: ${secret.orgId}, Token: ${secret.token}, Expired Time: ${secret.expiredTime}`);
  }
  process.exit(0);
};

main();

export const dropTable = async () => {
  await sequelize.query('DROP TABLE IF EXISTS "cf_user_secrets"');
  console.log('UserSecret table dropped');
  process.exit(0);
};

// dropTable()

const token1 = 'sk_tvwzgp5lky8iupawh0encvd52vji4o8argvd2x668gn15q83xpgo8fe10ny7wfsq';
const orgToken2 = 'sk_x37p8iifh6k18c3f121w49nmfy1sbjqpyol9fcsz0lmc5dz493wrfwvtxc4gi9od';

export const main2 = async () => {
  const redis = useContextKey('redis');
  if (!redis) {
    console.error('Redis is not initialized');
    return;
  }
  const models = await initUser();
  const UserSecret = models.UserSecret;
  const v = await models.UserSecret.verifyToken(token1);
  console.log('verifyToken', v);
  process.exit(0);
};

// main2();
